#include <stdio.h>
#include <stdlib.h>

struct node 
{
   int          data;
   struct node* next;
};

int Length(char * name , struct node* head) 
{
   struct node* current = head;
   int count = 0;
   while (current != NULL) 
   {
      count++;
      current = current->next;
   }
   return count;
}

int Pop(struct node** headRef) 
{
   struct node* head;
   int result;
   head = *headRef;
   if(head==NULL) return NULL;	
   result = head->data; // pull out the data before the node is deleted
   *headRef = head->next;      // unlink the head node for the caller
                         // Note the * -- uses a reference-pointer
                         // just like Push() and DeleteList().
   free(head);           // free the head node
   return(result);       // don't forget to return the data from the link
}

void Add(struct node** headRef, int num) 
{
   struct node* current = *headRef;
   struct node* newNode;
   newNode = malloc(sizeof(struct node));
   newNode->data = num;
   newNode->next = NULL;
   // special case for length 0
   if (current == NULL) {
      *headRef = newNode;
   }
   else {
      // Locate the last node
      while (current->next != NULL) {
          current = current->next;
      }
      current->next = newNode;
   }
}

